-------------------------------------lib_ondas version inicial--------------------------------------------
---------------------------------------Autor: ferferfer111------------------------------------------------
-----------------------------------------Web: PSPSCENEBETA------------------------------------------------
-------------------------------Porteada a LUA DEV por: erpi----------------------------------------------
---------------Libreria para simular ondas unicamente compatible con LuaDEV---------------------
--Si quereis contactar conmigo por algun problema, buscadme en PSPSCENEBETA, con el nick de ferferfer111--
---------------------------Ya que ferferfer111 es el autor original de la libreria-------------------------


-------------Me gustaria dar las gracias a PIPAGERARDO y a PSPSCENEBETA por sus tutoriales-----------------

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--Funciones:

--onda1=Cargar_onda1([frecuencia])--> Retorna una tabla con los parametros y funciones correspondientes al tipo de onda1, en otras palabras, carga la onda1. Se puede establecer un argumento optativo a esta funcion, que es la rapidez con que se mueve la onda. Recomiendo que sea un parametro entre el 0 y el 1, nunca siendo este el 0 o la aplicacion se congelara. La frecuencia por defecto es 0.1.
--onda2=Cargar_onda2([frecuencia])--> Retorna una tabla con los parametros y funciones correspondientes al tipo de onda2, en otras palabras, carga la onda2. Se puede establecer un argumento optativo a esta funcion, que es la rapidez con que se mueve la onda. Recomiendo que sea un parametro entre el 0 y el 1, nunca siendo este el 0 o la aplicacion se congelara. La frecuencia por defecto es 0.1.
--onda3=Cargar_onda3([frecuencia])--> Retorna una tabla con los parametros y funciones correspondientes al tipo de onda3, en otras palabras, carga la onda3. Se puede establecer un argumento optativo a esta funcion, que es la rapidez con que se mueve la onda. Recomiendo que sea un parametro entre el 0 y el 1, nunca siendo este el 0 o la aplicacion se congelara. La frecuencia por defecto es 0.1.
--onda1:color(r,g,b)--> Establece el color de la onda cargada anteriormente. Requiere tres argumentos, que son los parametros rgb del color. Si no se hace uso de esta funcion, el color por defecto establecido es el azul.
--onda1:ejecutar([desfase])--> Comienza a dibujar en pantalla la onda cargada anteriormente. A esta funcion se le puede dar un argumento optativo que se trata de un numero que vaya del 1 al 9. Este argumento sirve para que las ondas(si es que dibujais varias a la vez) no empiecen a la misma vez, si no que empiecen desfasadas y asi darle un toque mas chulo. 


--Funcionamiento:


--Para dibujar una onda(pongo "wave" en vez de "onda" para que veais que se puede llamar a la onda como querais):

--code para lua hm7
--blanco = color.new(255,255,255,255)
--dofile("./lib_ondas.lua")
--wave = cargar_onda1()
--wave:color(255,0,0)
--while true do
--screen.clear(blanco)
--wave:ejecutar()
--screen.flip()
--end


--Para dibujar varias ondas:

--blanco = color.new(255,255,255,255)
--dofile("./lib_ondas.lua")
--onda1 = Cargar_onda1()
--onda1:color(255,0,0)
--onda2 = Cargar_onda2()
--onda2:color(0,255,0)
--onda3 = Cargar_onda3()
--while true do
--screen.clear(blanco)
--onda1:ejecutar()
--onda2:ejecutar(3)
--onda3:ejecutar(7)
--screen.flip()
--end


--Otro ejemplo(la misma onda dos veces):

--blanco = color.new(255,255,255,255)
--dofile("./lib_ondas.lua")
--onda1 = Cargar_onda1()
--onda2 = Cargar_onda1(0.2)
--onda1:color(255,0,0)
--while true do
--screen.clear(blanco)
--onda1:ejecutar()
--onda2:ejecutar(5)
--screen.flip()
--end


--Para que la onda cambie de color(de verde a amarillo por ejemplo):

--blanco = color.new(255,255,255,255)
--dofile("./lib_ondas.lua")
--r=0
--onda1 = Cargar_onda1()
--while true do
--onda1:color(r,255,0)
--screen.clear(blanco)
--onda1:ejecutar()
--screen.flip()
--if r <= 0 then
--aumento = true
--elseif r >= 128 then
--aumento = false
--end
--if aumento then
--r = r +0.1
--else
--r = r-0.1
--end
--end


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------




--Funcion para la 1 onda--


Cargar_onda1 = function(f)
f=f or 0.1
local onda={pi=math.pi,Frec=f,Long_onda=2000,Amplitud=100}
function onda:color(a,b,c) self.a=a self.b=b self.c=c end
function onda:ejecutar(desfase)
desfase=desfase or 0
if not self.contador then
self.contador=timer.new()
self.contador:reset(0)
self.contador:start()
end
if not self.a or not self.b or not self.c then
self.a = 0
self.b = 0
self.c = 255
end
local t,x,y,i
t = self.contador:time()/1000+desfase
for x = 0,480,4 do
y = 136+self.Amplitud*math.sin(2*self.pi*(t*self.Frec-x/self.Long_onda))
i = self.Amplitud*(-2*self.pi/self.Long_onda)*math.cos(2*self.pi*(t*self.Frec-x/self.Long_onda))
draw.line(x-200,y-i*200,x+200,y+i*200,color.new(self.a,self.b,self.c,x/40))
end
collectgarbage()
end
return onda
end

--Funcion para la 2 onda--

Cargar_onda2 = function(f)
f=f or 0.1
local onda={pi=math.pi,Frec=f,Long_onda=2000,Amplitud=110}
function onda:color(a,b,c) self.a=a self.b=b self.c=c end
function onda:ejecutar(desfase)
desfase=desfase or 0
if not self.contador then
self.contador=timer.new()
self.contador:reset(0)
self.contador:start()
end
if not self.a or not self.b or not self.c then
self.a = 0
self.b = 0
self.c = 255
end
local t,x,y,i,a
t = self.contador:time()/1000+desfase
if self.Amplitud <= 5 then
self.aumento = true
elseif self.Amplitud >= 110 then
self.aumento = false
end
if self.aumento then
self.Amplitud = self.Amplitud +0.1
else
self.Amplitud = self.Amplitud-0.1
end
for x = 0,480,10 do
y = 136+self.Amplitud*math.sin(2*self.pi*(t*self.Frec-x/self.Long_onda))
i = self.Amplitud*(-2*self.pi/self.Long_onda)*math.cos(2*self.pi*(t*self.Frec-x/self.Long_onda))
for a = -3,3 do
draw.line(x-20,a+y-i*20,x+20,a+y+i*20,color.new(self.a,self.b,self.c,25-math.abs(a*5)))
end
end
collectgarbage()
end
return onda
end

--Funcion para la 3 onda--

Cargar_onda3 = function(f)
f=f or 0.1
local onda={pi=math.pi,Frec=f,Long_onda=1500,Amplitud=50}
function onda:color(a,b,c) self.Color=color.new(a,b,c,40) end
function onda:ejecutar(desfase)
desfase=desfase or 0
if not self.contador then
self.contador=timer.new()
self.contador:reset(0)
self.contador:start()
end
if not self.Color then
self.Color=color.new(0,0,255,40)
end
local t,x,y,i
t = self.contador:time()/1000+desfase
for x = 0,480 do
y = 200+self.Amplitud*math.sin(2*self.pi*(t*self.Frec-x/self.Long_onda))
draw.line(x,272,x,y,self.Color)
end
collectgarbage()
end
return onda
end